image: python:3.6

stages:
  - test
  - build
  - publish

black:
  stage: test
  tags:
    - docker
  except:
    - tags
  before_script:
    - pip install black
  script:
    - make black

pylama:
  stage: test
  tags:
    - docker
  except:
    - tags
  before_script:
    - pip install pylama==7.7.1
    - pip uninstall -y pyflakes
    - pip install pyflakes==2.4.0
  script:
    - make pylama

build:
  stage: build
  tags:
    - docker
  script:
    - make package
  artifacts:
    paths:
      - dist/

test install:
  stage: build
  tags:
    - docker
  needs: ["build"]
  image: registry.gitlab.com/ifb-elixirfr/docker-images/mamba:0-13-0
  before_script:
    - mamba install -y python-ldap==3.3.1 zeroc-ice=3.6.5
  script:
    - pip install dist/ifb-openlink*
    - openlink --help
    - python -c "import openlink.connectors.openlink_labguru"
    - python -c "import openlink.connectors.openlink_omero"
    - python -c "import openlink.connectors.openlink_seafile"
    - python -c "import openlink.connectors.openlink_ssh"
    - python -c "import openlink.connectors.openlink_zenodo"


test.pypi.org:
  stage: publish
  tags:
    - docker
  only:
    - master
  when: manual
  variables:
    PYPI_PASSWORD: $PASSWORD_PIPY
  before_script:
    - pip install twine
    - cp ci/pypirc ~/.pypirc
    - sed -i -e 's/TEST_PYPI_PASSWORD/'$PYPI_PASSWORD'/g' ~/.pypirc
  script:
    - twine upload --repository testpypi dist/*

pypi.org:
  stage: publish
  tags:
    - docker
  only:
    - tags
  variables:
    PYPI_PASSWORD: $PASSWORD_PIPY
  before_script:
    - pip install twine
    - cp ci/pypirc ~/.pypirc
    - sed -i -e 's/PYPI_PASSWORD/'$PYPI_PASSWORD'/g' ~/.pypirc
  script:
    - twine upload --repository pypi dist/*
